import request from "@/utils/request.js";

// 创建奖品
export function createPrize(data) {
  return request({
    url: "/engine/activity-prize/create",
    method: "post",
    data: data
  });
}
// 删除奖品
export function deletePrize(id) {
  return request({
    url: "/engine/activity-prize/delete?id=" + id,
    method: "delete"
  });
}
// 获得单个奖品
export function getPrize(id) {
  return request({
    url: "/engine/activity-prize/get?id=" + id,
    method: "get"
  });
}
// 获取奖品类型
export function getCode(data) {
  return request({
    url: "/engine/activity-prize/getCode",
    method: "get"
  });
}
// 获取奖品分页
export function getPrizePageList(pageNo, pageSize, prizeName, prizeType) {
  return request({
    url: `/engine/activity-prize/page?pageNo=${pageNo}&pageSize=${pageSize}&prizeName=${prizeName}&prizeType=${prizeType}`,
    method: "get"
  });
}
// 更新奖品
export function updatePrize(data) {
  return request({
    url: "/engine/activity-prize/update",
    method: "put",
    data: data
  });
}
// 获取奖品下拉列表
export function selectList() {
  return request({
    url: "/engine/activity-prize/selectList",
    method: "get"
  });
}
