import request from "@/utils/request.js";

//
export const createGenerate = (data) => {
  return request({
    url: "/wechat/generate/create",
    method: "post",
    data
  });
};
export const getGeneratePage = (pageNo, pageSize, name, status) => {
  return request({
    url: `/wechat/generate/page?pageNo=${pageNo}&pageSize=${pageSize}&name=${name}&status=${status}`,
    method: "get"
  });
};
export const deleteGenerate = (id) => {
  return request({
    url: "wechat/generate/delete?id=" + id,
    method: "delete"
  });
};
export const getOnlyGenerate = (id) => {
  return request({
    url: "wechat/generate/get?id=" + id,
    method: "get"
  });
};
export const getDownloadZip = (id) => {
  return request({
    url: "wechat/generate/downloadZip?id=" + id,
    method: "get",
    headers: {
      "Content-Type": "application/json; application/octet-stream"
    },
    responseType: "blob"
  });
};
