import Vue from "vue";
import Vuex from "vuex";
import app from "./modules/app";
import user from "./modules/user";
import tagsView from "./modules/tagsView";
import permission from "./modules/permission";
import settings from "./modules/settings";
import dict from "./modules/dict";
import getters from "./getters";
import state from "./state";
import mutations from "./mutations";
import material from "./material";
import compDetail from "./dargModules/compDetail";
import H5 from "./H5/h5";

Vue.use(Vuex);

const store = new Vuex.Store({
  modules: {
    app,
    user,
    tagsView,
    permission,
    settings,
    dict,
    H5
  },
  getters,
  state,
  mutations,
  material
});

export default store;
