import module from "@/util/module.js";
import { zIndexUp, zIndexDown } from "@/util/swap-array.js";
import { Message } from "element-ui";
import _ from "lodash";
export default {
  // 拿到接口数据
  init(state, vals) {
    let val = vals;
    for (let i = 0; i < val.pageList.length; i++) {
      val.pageList[i].pageStyle = JSON.parse(val.pageList[i].pageStyle);
      for (let j = 0; j < val.pageList[i].compList.length; j++) {
        val.pageList[i].compList[j].compStyle = JSON.parse(val.pageList[i].compList[j].compStyle);
      }
    }

    // 保存整个数据
    state.module.moduleConfig = JSON.parse(JSON.stringify(vals));
    // 分离数据
    if (state.module.moduleConfig.pageList.length > 0) {
      state.pageList = state.module.moduleConfig.pageList;
      if (state.pageList.length > 0) {
        state.diyPage = state.pageList[0];
        state.pageOnlyId = 0;
        if (state.diyPage.compList.length > 0) {
          state.compList = state.diyPage.compList;
          if (state.compList.length > 0) {
            state.control = state.compList[0];
            state.compOnlyId = 0;
          }
        }
      }
    }
    let date = new Date().getTime();
    state.pageUpdate = date;
    state.update = date;
    RecordData(state);
    // id cid
  },
  // 向当前活动保存信息
  keepMarkData(state, obj) {
    state.module.moduleConfig = { ...state.module.moduleConfig, ...obj };
  },
  // 保存页面信息
  keepPreview(state) {
    state.diyPage.compList = JSON.parse(JSON.stringify(state.compList));
    state.pageList[state.pageOnlyId] = JSON.parse(JSON.stringify(state.diyPage));
    state.module.moduleConfig.pageList = JSON.parse(JSON.stringify(state.pageList));
  },

  // 保存组件数据 con => 组件列表
  PRESERVE_COM(state) {
    state.compList[state.compOnlyId] = state.control;
  },
  // 保存组件列表 clist => diyPage
  PRESERVE_COM_LIST(state) {
    state.diyPage.compList = state.compList;
  },
  // 保存当前页数据 diy => pageList
  PRESERVE_ONLY_PAGE(state) {
    state.pageList[state.pageOnlyId] = state.diyPage;
  },
  // 全保存 pageList => module
  // 更改预览状态
  // keep只保存 否则进行预览
  setPreview(state, keep) {
    if (keep) {
      state.pageList[state.pageOnlyId] = JSON.parse(JSON.stringify(state.diyPage));
      state.module.moduleConfig.pageList = JSON.parse(JSON.stringify(state.pageList));
    }
    // 更改状态
    state.preview = !state.preview;
    state.compOnlyId = -1;
  },
  // 是否显示控件
  show(state) {
    state.showAttr = !state.showAttr;
  },
  ondiyPage(state) {
    // 将预览页面添加到页面列表中去
    state.pageList[state.pageOnlyId] = JSON.parse(JSON.stringify(state.diyPage));
  },
  // 更新页面onlyID 移动页面
  updatePageList(state, data) {
    // 删除开始页的数据，插入指定位置的数据
    state.pageOnlyId = data.index2;
    [state.pageList[data.index1], state.pageList[data.index2]] = [
      state.pageList[data.index2],
      state.pageList[data.index1]
    ];
    state.pageUpdate = new Date().getTime();
  },
  // 获取当前点击页面
  onPage(state, index) {
    // 当前页
    // 保存组件
    state.compList[state.compOnlyId] = state.control;
    // 保存组件列表
    state.diyPage.compList = state.compList;
    // 保存页面
    state.pageList[state.pageOnlyId] = JSON.parse(JSON.stringify(state.diyPage));
    // 如果预览页有数据
    // if (JSON.stringify(state.diyPage) !== "{}") {
    //   state.compList[state.compOnlyId] = state.control;
    //   // 保存预览页前页面信息
    //   state.diyPage.compList = JSON.parse(JSON.stringify(state.compList));
    //   state.pageList[state.pageOnlyId] = JSON.parse(JSON.stringify(state.diyPage));
    // }
    // 如果预览页面中没有信息
    // 获取当前页面信息，并添加到预览页面中去
    state.pageOnlyId = index;
    state.diyPage = JSON.parse(JSON.stringify(state.pageList[index]));
    state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
    state.control = {};
    state.compOnlyId = -1;
    state.pageAttr = true;
    // 将页面id替换成下标
  },
  // 重置信息
  Reset(state) {
    state.module = {}; //项目信息
    state.pageList = []; //页面列表
    state.pageOnlyId = -1; //选定的页面id渲染在页面上的
    state.compOnlyId = -1; //正在展示的组件id
    state.globalStyle = {}; //全局样式
    state.diyPage = {}; // 当前正在展示的diy页面
    state.preview = false; //是否正在预览
    state.pageAttr = false; //是否显示页面管理面板
    state.compList = []; //组件列表
    state.control = []; //当前正在展示的组件，完整数据
  },
  // 增加页面 complist diy page
  addPageList(state) {
    state.diyPage.compList = JSON.parse(JSON.stringify(state.compList));
    state.pageList[state.pageOnlyId] = JSON.parse(JSON.stringify(state.diyPage));
    state.compList = [];
    state.diyPage = [];
    state.control = [];
    state.compOnlyId = -1;

    // 新增自定义页面列表
    // 页面需要信息
    let obj = {
      // 页面配置，单独设置
      pageName: "自定义页面",
      pageCode: "",
      pageStyle: JSON.parse(JSON.stringify(module.PageGlobal)),
      operator: "",
      pageDescribe: "",
      createTime: "",
      updateTime: "",
      compList: []
    };
    // 向页面列表添加数据
    state.pageList.push(obj);
    // 向预览页面内添加数据

    state.pageOnlyId = state.pageList.length - 1;
    state.diyPage = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId]));
    // 当前正在展示的页面id
    // 正在展示的组件列表
    state.compList = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId].compList));
    state.pageUpdate = new Date().getTime();
    RecordData(state);
  },
  // 模板信息更改
  SetModuleConfig(state, val) {
    state.module.moduleConfig = JSON.parse(JSON.stringify(val));
    RecordData(state);
  },
  copyPage(state) {
    if (state.pageList.length < 1) return;
    state.pageList.splice(state.pageOnlyId, 0, state.pageList[state.pageOnlyId]);
    state.pageOnlyId += 1;
    // state.pageList[state.pageOnlyId].delete(id)
    if (state.pageList[state.pageOnlyId].id != "undefined") {
      delete state.pageList[state.pageOnlyId].id;
    }
    state.pageList[state.pageOnlyId].compList.forEach((item) => {
      if (item.id != "undefined") {
        delete item.id;
      }
    });
    state.diyPage = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId]));
    RecordData(state);
  },
  // 添加动画
  addAnimation(state, arr) {
    state.control.compStyle.AnimationList.push(arr);
    state.compList[state.compOnlyId].compStyle.AnimationList = JSON.parse(
      JSON.stringify(state.control.compStyle.AnimationList)
    );
    RecordData(state);
  },
  // 删除动画
  deleteAnimation(state, i) {
    state.control.compStyle.AnimationList.splice(i, 1);
    state.compList[state.compOnlyId].compStyle.AnimationList = JSON.parse(
      JSON.stringify(state.control.compStyle.AnimationList)
    );
    RecordData(state);
  },
  // 删除页面    diyPage在删除第一个元素时无值
  deletPageList(state, index) {
    // 删除指定元素
    state.pageList.splice(index, 1);
    const setData = function () {
      state.pageOnlyId -= 1;
      state.diyPage = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId]));
      // 重置信息
      state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
      state.control = {};
      state.compOnlyId = -1;
    };
    // 删除第一个唯一一个页面
    if (index == 0) {
      // 无页面数据
      if (state.pageList.length == 0) {
        // 重置信息
        state.pageOnlyId = -1;
        state.diyPage = {};
        state.compList = [];
        state.control = {};
        state.compOnlyId = -1;
      } else {
        if (state.pageOnlyId == 0) {
          state.pageOnlyId = 0;
          state.diyPage = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId]));
          // 重置信息
          state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
          state.control = {};
          state.compOnlyId = -1;
        } else {
          setData();
        }
      }
      // 如果选中项在删除项后 并且数量大于等于1
    } else if (state.pageOnlyId > index && state.pageList.length >= 1 && state.pageOnlyId > 0) {
      setData();
    } else if (state.pageOnlyId == index) {
      if (state.pageList.length > 0) {
        setData();
      }
    }
    // // 页面信息
    // state.pageOnlyId = state.pageList.length - 1;
    // state.compOnlyId = -1;
    // //
    // if (index > 0) {
    //   state.diyPage = JSON.parse(JSON.stringify(state.pageList[index - 1]));
    // }
    // // 删除最后一个页面，退出预览
    // if (index == 0) {
    //   state.preview = false;
    // }
    // 通知页面变化
    state.pageUpdate = new Date().getTime();
    RecordData(state);
  },
  // 添加新的组件
  addComponent(state, indexList) {
    //如果存在组件， 保存上一个组件数据
    if (Object.keys(state.control).length > 0 && state.compOnlyId !== -1) {
      state.compList[state.compOnlyId] = JSON.parse(JSON.stringify(state.control));
      //  清空当前正在展示的组件信息
    }
    // 新建组件
    let obj = {
      ...module.dragList[indexList[0]].list[indexList[1]]
    };
    // console.log(obj);
    // 正在预览组件
    state.control = obj;
    state.control.compStyle.position.top += 10;
    state.control.compStyle.position.left = state.componentPosition.left;
    state.control.compStyle.position.zIndex = state.componentPosition.zIndex;
    state.control.compStyle.position.rotate = state.componentPosition.rotate;
    state.compOnlyId = state.compList.length;
    state.compList.push(JSON.parse(JSON.stringify(state.control)));
    state.diyPage.compList = JSON.parse(JSON.stringify(state.compList));
    RecordData(state);
  },
  // 删除当前页所有组件
  deletAllComp(state) {
    state.compList = [];
    state.control = [];
    state.diyPage.compList = [];
    state.pageList[state.pageOnlyId] = JSON.parse(JSON.stringify(state.diyPage));
    state.compOnlyId = -1;
    RecordData(state);
  },
  //  删除组件
  deletComp(state) {
    // 如果没有组件 或者未选中组件
    if (state.compList.length <= 0 || state.compOnlyId < 0) {
      return;
    } else {
      if (state.compList.length == 1) {
        // 如果是唯一组件，删除后组件坐标归-1，
        state.compList.splice(state.compOnlyId, 1);
        state.diyPage.compList = JSON.parse(JSON.stringify(state.compList));
        state.compOnlyId = -1;
        state.control = {};
      } else {
        //多个组件删除当前组件 组件下标 + /-
        // 删除第二个组件 -1
        if (state.compOnlyId !== 0) {
          state.compList.splice(state.compOnlyId, 1);
          state.diyPage.compList = JSON.parse(JSON.stringify(state.compList));
          state.compOnlyId -= 1;
        } else {
          state.compList.splice(state.compOnlyId, 1);
          state.diyPage.compList = JSON.parse(JSON.stringify(state.compList));
        }
      }
    }
    RecordData(state);
  },
  //获取正在点击的组件
  onComp(state, index) {
    state.control = JSON.parse(JSON.stringify(state.compList[index]));
    state.compOnlyId = index;
    state.pageAttr = false;
  },
  // 更改组件列表
  setCompList(state, arr) {
    state.compList = JSON.parse(JSON.stringify(arr));
    state.diyPage.compList = JSON.parse(JSON.stringify(arr));
    // state.control =
    RecordData(state);
  },
  setCompListOnComp(state, index) {
    state.compOnlyId = index;
    RecordData(state);
  },
  copyComp(state) {
    if (state.compList.length < 1 || state.pageList.length < 1 || state.diyPage.compList.length < 1)
      return;
    let data = JSON.parse(JSON.stringify(state.compList[state.compOnlyId]));
    data.compStyle.position.top -= 20;
    data.compStyle.position.left -= 20;
    state.compList.splice(state.compOnlyId, 0, JSON.parse(JSON.stringify(data)));

    state.pageList.compList = JSON.parse(JSON.stringify(state.compList));
    state.compOnlyId += 1;

    delete state.compList[state.compOnlyId].id;
    RecordData(state);
  },
  // 设置 组件配置
  setCompConfig(state, val) {
    state.control[val.name] = val.val;
    state.compList[state.compOnlyId][val.name] = val.val;
    RecordData(state);
  },
  // 更改组件样式
  setCompStyle(state, val) {
    state.control.compStyle = JSON.parse(JSON.stringify(val));
    state.compList[state.compOnlyId].compStyle = JSON.parse(JSON.stringify(val));
    state.compList = JSON.parse(JSON.stringify(state.compList));
    let date = new Date().getTime();
    state.update = date;
    RecordData(state);
  },

  //  // 组件顺序变更
  // 拖动组件
  swap(state, index) {
    //更新数组数据
    //顺序切换，更新组件列表，获取当前组件，组件下标
    state.control = JSON.parse(JSON.stringify(state.compList[index]));
    state.compOnlyId = index;
    RecordData(state);
  },
  //
  dragDelete(state) {
    state.compOnlyId -= 1;
    if (state.compOnlyId != -1) {
      state.control = JSON.parse(JSON.stringify(state.compList[state.compOnlyId]));
    }
    RecordData(state);
  },
  // 上
  compUp(state) {
    if (state.compOnlyId <= 0) {
      Message({
        message: "已经到底了~",
        type: "warning"
      });
      return;
    } else {
      zIndexUp(state.compList, state.compOnlyId, state.compOnlyId - 1);
      state.control = state.compList[state.compOnlyId - 1];
      state.compOnlyId -= 1;
      RecordData(state);
    }
  },
  // 下
  compDown(state) {
    if (state.compList.length - 1 === state.compOnlyId) {
      Message({
        message: "已经到顶了~",
        type: "warning"
      });
      return;
    } else {
      zIndexDown(state.compList, state.compOnlyId, state.compOnlyId + 1);
      state.control = state.compList[state.compOnlyId + 1];
      state.compOnlyId += 1;
      RecordData(state);
    }
  },
  // 置顶，
  compTop(state, index) {
    if (state.compOnlyId <= 0) {
      Message({
        message: "已经到底了~",
        type: "warning"
      });
      return;
    } else {
      // 插入到第一条
      state.compList.unshift(state.compList[state.compOnlyId]);
      // 删除当前条
      state.diyPage.compList.splice(state.compOnlyId + 1, 1);
      state.compList.splice(state.compOnlyId + 1, 1);
      state.compOnlyId = 0;
      RecordData(state);
    }
  },
  // 置底
  compBottom(state) {
    if (state.compList.length - 1 === state.compOnlyId) {
      Message({
        message: "已经到顶了~",
        type: "warning"
      });
      return;
    } else {
      state.compList.push(state.compList[state.compOnlyId]);
      state.diyPage.compList.splice(state.compOnlyId, 1);
      state.compList.splice(state.compOnlyId, 1);
      state.compOnlyId = state.compList.length - 1;
      RecordData(state);
    }
  },

  // 修改module配置信息
  setModule(state, obj) {
    state.module.moduleConfig = JSON.parse(JSON.stringify(obj));
    RecordData(state);
    // state.module.
    // let date = new Date().getTime()
    // state.PageUpdate = date
  },
  //修改全局样式
  setDiyPageStyle(state, obj) {
    // console.log(obj,"obj");
    if (JSON.stringify(obj) !== JSON.stringify(state.diyPage.pageStyle)) {
      state.diyPage.pageStyle = JSON.parse(JSON.stringify(obj));
      let date = new Date().getTime();
      state.pageUpdate = date;
      RecordData(state);
    }
  },

  // 更新页面配置
  setPageData(state, val) {
    state.diyPage[val.name] = val.val;
    state.pageList[state.pageOnlyId][val.name] = val.val;
    let date = new Date().getTime();
    state.pageUpdate = date;
    RecordData(state);
  },

  //配置显示
  showPageAttr(state) {
    state.pageAttr = true;
  },
  // 切换到指定页
  onlyPage(state, id) {
    state.pageOnlyId = id;
    state.diyPage = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId]));
    state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
  },
  setOnlyPage(state, id) {
    state.pageOnlyId = id;
    state.diyPage = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId]));
    state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
  },
  // 预览 切换
  // 下一页
  nextPage(state) {
    state.pageOnlyId += 1;
    state.diyPage = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId]));
    state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
  },
  // 上一页
  prevPage(state) {
    // 预览页面
    // 页面列表中
    // 页面下标
    state.pageOnlyId -= 1;
    state.diyPage = JSON.parse(JSON.stringify(state.pageList[state.pageOnlyId]));
    state.compList = JSON.parse(JSON.stringify(state.diyPage.compList));
  },
  updateScale(state, val) {
    state.scale = val;
  },
  // 是否显示素材管理
  setShowMaterial(state) {
    state.showMaterial = !state.showMaterial;
  },
  setImageUrl(state, url) {
    state.imageUrl = JSON.parse(JSON.stringify(url));
  },
  setPosition(state, { top, left }) {
    state.componentPosition.top = top;
    state.componentPosition.left = left;
  },
  setRuleData(state, data) {
    state.ruleData = data;
  },
  // 记录数据
  RecordDatas(state) {
    let Time = new Date().getTime();
    let data = {
      module: _.cloneDeep(state.module),
      pageList: _.cloneDeep(state.pageList),
      pageOnlyId: _.cloneDeep(state.pageOnlyId),
      compOnlyId: _.cloneDeep(state.compOnlyId),
      globalStyle: _.cloneDeep(state.globalStyle),
      diyPage: _.cloneDeep(state.diyPage),
      compList: _.cloneDeep(state.compList),
      update: Time,
      pageUpdate: Time
    };
    state.RecordData.push(_.cloneDeep(data));
    // 数组下标
    state.RecordDataID = state.RecordData.length - 1;
  },
  // 撤销
  prveRecordData(state) {
    console.log("pr");
    // 没有数据
    if (state.RecordData.length == 0) return;
    // 到第一步 无上一步
    if (state.RecordDataID > 0) {
      state.RecordDataID = state.RecordDataID - 1;
      Object.keys(state.RecordData[state.RecordDataID]).map((val) => {
        state[val] = _.cloneDeep(state.RecordData[state.RecordDataID][val]);
      });
    } else {
      Message({
        type: "warning",
        message: "已是开始数据"
      });
    }
  },
  // 恢复
  nextRecordData(state) {
    console.log("re");
    // 没有数据
    if (state.RecordData.length == 0) return;
    // 最后一步
    if (state.RecordDataID < state.RecordData.length - 1) {
      state.RecordDataID = state.RecordDataID + 1;
      Object.keys(state.RecordData[state.RecordDataID]).map((val) => {
        state[val] = _.cloneDeep(state.RecordData[state.RecordDataID][val]);
      });
    } else {
      Message({
        type: "warning",
        message: "已是最新数据"
      });
    }
  },
  setUserData(state, data) {
    state.userInfoData = data;
  },
  // 重置记录
  resetRecordData(state) {
    (state.RecordData = []), (state.RecordDataID = -1);
  },
  // 设置网格信息
  setGirdCfg(state, obj) {
    state.cfgGird = JSON.parse(JSON.stringify(obj));
  }
};
let flag = true;
export const RecordData = (state) => {
  if (flag) {
    setTimeout(() => {
      let Time = new Date().getTime();
      let data = {
        module: _.cloneDeep(state.module),
        pageList: _.cloneDeep(state.pageList),
        pageOnlyId: _.cloneDeep(state.pageOnlyId),
        compOnlyId: _.cloneDeep(state.compOnlyId),
        globalStyle: _.cloneDeep(state.globalStyle),
        diyPage: _.cloneDeep(state.diyPage),
        compList: _.cloneDeep(state.compList),
        update: Time,
        pageUpdate: Time
      };
      state.RecordData.push(_.cloneDeep(data));
      // 数组下标
      state.RecordDataID = state.RecordData.length - 1;
      flag = true;
    }, 500);
  }
  flag = false;
  // 设置用户信息
};
