import store from "@/store/index.js";
import router from "@/router/index";
import { upDateModule } from "@/api/module/module.js";
import { updateMarket } from "@/api/module/module.js";
import { Message } from "element-ui";
import { throttle } from "@/util/debounce";
import vueThis from "@/main";

/**
 * z 90
 * y 89
 * s 83
 * c 67
 * 上38
 * 下40
 * 左37
 * 右39
 */
export const keyCode = function (e) {
  e.preventDefault();
  let code = e.keyCode;
  let altKey = e.altKey;
  let ctrlKey = e.ctrlKey;
  let shiftKey = e.shiftKey;
  if (ctrlKey && !altKey && !shiftKey) {
    // ctrlkey
    switch (code) {
      case 90:
        // 撤销
        // prveRecordData
        store.commit("prveRecordData");
        break;
      case 89:
        // 恢复nextRecordData
        store.commit("nextRecordData");
        break;
      case 83:
        // 保存
        store.commit("keepPreview");
        keepData();
        break;
      case 38:
        // 上移图层
        store.commit("compDown");
        break;
      case 40:
        store.commit("compUp");
        // 下移图层
        break;
      case 67:
        // 复制组件
        store.commit("copyComp");
        break;
      default:
        break;
    }
  } else if (shiftKey && !ctrlKey && !altKey) {
    // shift
  } else if (altKey && !shiftKey && !ctrlKey) {
    // alt
  } else if (ctrlKey && shiftKey && !altKey) {
    // ctrl + shift
    switch (code) {
      case 38:
        // 置顶图层
        store.commit("compBottom");
        break;
      case 40:
        // 置底图层
        store.commit("compTop");
        break;
      // case 67:
      //   // 复制页面
      //   store.commit("copyPage");
      //   break;
      default:
        break;
    }
  } else {
    switch (code) {
      case 8:
        // 删除
        store.commit("deletComp");
        break;
      case 38:
        // 上
        changPosition(1, "上");
        break;
      case 39:
        // 右
        changPosition(1, "右");
        break;
      case 40:
        // 下
        changPosition(1, "下");
        break;
      case 37:
        // 左
        changPosition(1, "左");
        break;

      default:
        break;
    }
  }
};
function keepData() {
  let type = router.currentRoute.path == "/diy/drag" ? false : true;
  let params = JSON.stringify(store.state.module);
  if (type) {
    updateMarket(params).then((res) => {
      Message({
        message: "保存成功",
        type: "success"
      });
    });
  } else {
    upDateModule(params).then((res) => {
      Message({
        message: "保存成功",
        type: "success"
      });
    });
  }
}
function changPosition(step = 1, direction = "上") {
  // vueThis.$nextTick(() => {
  let compStyle = JSON.parse(JSON.stringify(store.state.control.compStyle));
  if (direction == "上") {
    compStyle.position.top -= step;
  } else if (direction == "右") {
    compStyle.position.left += step;
  } else if (direction == "下") {
    compStyle.position.top += step;
  } else if (direction == "左") {
    compStyle.position.left -= step;
  }
  store.commit("setCompStyle", compStyle);
  // });
}
