import G6 from "@antv/g6";

export const superLongTextHandle = (str, maxWidth, fontSize) => {
  str = str.replace(/<\/?.+?>/g, "");
  str = str.replace(/[\r\n]/g, "");
  //去除左侧空格
  str = str.replace(/^\s*/g, "");
  //去右空格
  str = str.replace(/\s*$/g, "");
  //去掉字符串两端的空格
  str = str.replace(/(^\s*)|(\s*$)/g, "");
  //去除字符串中间空格
  str = str.replace(/\s/g, "");
  let currentWidth = 0;
  let res = str;
  // 区分汉字和字母
  const pattern = new RegExp("[\u4E00-\u9FA5]+");
  str.split("").forEach((letter, i) => {
    if (currentWidth > maxWidth) return;
    if (pattern.test(letter)) {
      // 中文字符
      currentWidth += fontSize;
    } else {
      // 根据字体大小获取单个字母的宽度
      currentWidth += G6.Util.getLetterWidth(letter, fontSize);
    }
    if (currentWidth > maxWidth) {
      res = `${str.substr(0, i)}\n${superLongTextHandle(str.substr(i), maxWidth, fontSize)}`;
    }
  });
  return res;
};
