import html2canvas from "html2canvas";
// 页面元素转图片
export async function toImage(el) {
  console.log(el, "el");
  // 手动创建一个 canvas 标签
  const canvas = document.createElement("canvas");
  // 获取父标签，意思是这个标签内的 DOM 元素生成图片
  // imageTofile是给截图范围内的父级元素自定义的ref名称
  let canvasBox = el;
  // 获取父级的宽高
  const width = parseInt(window.getComputedStyle(canvasBox).width);
  const height = parseInt(window.getComputedStyle(canvasBox).height);
  // 宽高 * 2 并放大 2 倍 是为了防止图片模糊
  canvas.width = width * 2;
  canvas.height = height * 2;
  canvas.style.width = width + "px";
  canvas.style.height = height + "px";
  const context = canvas.getContext("2d");
  context.scale(2, 2);
  const options = {
    backgroundColor: null,
    canvas: canvas,
    useCORS: true
  };
  let dataURL = "";
  let res = await html2canvas(canvasBox, options);
  dataURL = res.toDataURL("image/png");
  return dataURL;
}
//下载图片
export function downloadImage(url) {
  // 如果是在网页中可以直接创建一个 a 标签直接下载
  let a = document.createElement("a");
  a.href = url;
  a.download = "首页截图";
  a.click();
}
